import { IMangoSelector, ICouchDocument, IFetchResponse, IFindResults } from '../Interfaces';
export interface IDocId {
    _id: string;
}
export interface IBulkDeleteItem {
    _id: string;
    _rev: string;
    _deleted: boolean;
}
export interface IBulkUpdateResponseItem {
    id: string;
    ok: boolean;
    rev: string;
}
export interface IBulkDeleteResponseItem {
    id: string;
    ok: boolean;
    rev: string;
}
export declare type BulkDeleteResponseList = IBulkDeleteResponseItem[];
export declare type BulkUpdateResponseList = IBulkUpdateResponseItem[];
export declare type BulkDeleteList = IBulkDeleteItem[];
export declare type DocIds = IDocId[];
export interface IBulkToolProvider {
    bulkDelete(docs: BulkDeleteList): Promise<BulkDeleteResponseList>;
    bulkUpdate(docs: ICouchDocument[]): Promise<BulkUpdateResponseList>;
    getIdList(selector: IMangoSelector): Promise<IFindResults>;
    getDocGroup(docs: IDocId[]): Promise<IFetchResponse>;
}
export declare class BulkToolProvider implements IBulkToolProvider {
    protected readonly db: any;
    constructor(db: any);
    bulkUpdate(docs: ICouchDocument[]): Promise<BulkUpdateResponseList>;
    bulkDelete(docs: BulkDeleteList): Promise<BulkDeleteResponseList>;
    getIdList(selector: IMangoSelector): Promise<IFindResults>;
    getDocGroup(docs: IDocId[]): Promise<IFetchResponse>;
}
