"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BulkToolProvider {
    constructor(db) {
        this.db = db;
    }
    bulkUpdate(docs) {
        return this.db.bulk({ docs });
    }
    bulkDelete(docs) {
        return this.db.bulk({ docs });
    }
    getIdList(selector) {
        const query = {
            selector,
            fields: ['_id'],
        };
        return this.db.find(query);
    }
    getDocGroup(docs) {
        const keys = docs.map(({ _id }) => _id);
        return this.db.fetch({ keys });
    }
}
exports.BulkToolProvider = BulkToolProvider;
