import { BulkUpdateResponseList, IBulkToolProvider } from './BulkTool';
import { ICouchProvider, IDocumentModificationResult, CouchDocument, ICouchFactory, IFindResults, IDocumentViewParams, ViewResultResponse, IMangoQuery, ICouchDocument } from './Interfaces/CouchTypes';
import { IAggregateView } from './View/AggregateView';
import { AggregateViewEngine } from './View/ViewEngine';
export declare class CouchFactory implements ICouchFactory {
    create(databaseName: string): Promise<ICouchProvider>;
}
export declare class CouchProvider implements ICouchProvider {
    db: any;
    private bulkTool;
    constructor(db: any);
    get(id: string): Promise<CouchDocument>;
    insert(data: any, id?: string): Promise<IDocumentModificationResult>;
    update(data: any, id: string, rev: string): Promise<IDocumentModificationResult>;
    bulkUpdate(docs: ICouchDocument[]): Promise<BulkUpdateResponseList>;
    delete(id: string, rev: string): Promise<IDocumentModificationResult>;
    find(query: IMangoQuery): Promise<IFindResults>;
    view(designDocument: string, view: string, options?: IDocumentViewParams): Promise<ViewResultResponse>;
    getBulkTool(): IBulkToolProvider;
    viewEngine(designDocument: string, aggregateViews: IAggregateView[]): AggregateViewEngine;
}
