import { IVersionedObject } from '../Utils/SemanticVersion';
import { IDesignDocManifestMap, IDesignDocSyncProvider, DesignDocManifest, IJsViewManifestMap, IJsViewManifest, DesignDocType, ViewManifestMap, ViewManifest, IMangoViewManifest, IMangoViewManifestMap, ViewMapItem, IMangoDesignDocManifest, JsViewMapItem, IJsDesignDocManifest, IMangoViewMapItem, IDesignDocument } from './Interfaces';
export declare class DesignDocSync {
    protected readonly provider: IDesignDocSyncProvider;
    protected readonly manifest: IDesignDocManifestMap;
    constructor(provider: IDesignDocSyncProvider, manifest: IDesignDocManifestMap);
    sync(): Promise<void>;
    private syncDesignDoc;
    private getViews;
    protected static NewDesignDoc(type: DesignDocType): IDesignDocument;
    protected static MergeViews(oldViews: {
        [viewName: string]: IVersionedObject;
    }, newViews: {
        [viewName: string]: IVersionedObject;
    }): any;
    protected static MergeView(oldView: IVersionedObject, newView: IVersionedObject): IVersionedObject;
    protected static ValidateView(docName: string, viewName: string, view: ViewManifest): void;
    protected static ValidateViewVersion(docName: string, viewName: string, version: any): void;
    protected static ValidateJsView(docName: string, viewName: string, item: ViewManifest): void;
    protected static ValidateMangoView(docName: string, viewName: string, item: IMangoViewManifest): void;
    protected static ViewsWereUpdated(oldViews: ViewManifestMap, newViews: ViewManifestMap): boolean;
    protected static ViewWasUpdated(viewName: string, oldView: ViewManifest, newView: ViewManifest): boolean;
    protected static MangoViewMapItemWasUpdated({ fields: oldFields }: IMangoViewMapItem, { fields: newFields }: IMangoViewMapItem): boolean;
    protected static EnsureMangoManifestOptionsObjects(viewManifest: IMangoViewManifestMap): void;
    protected static EnsureMangoOptionsObject(viewObject: IMangoViewManifest): void;
    protected static IsValidMangoOptionsObject(viewObject: IMangoViewManifest): boolean;
    protected static BuildMangoOptionsObject(viewObject: IMangoViewManifest): void;
    protected static IsJsDesignDocManifest(designDoc: DesignDocManifest): designDoc is IJsDesignDocManifest;
    protected static IsJsViewManifestMap(manifestMap: ViewManifestMap): manifestMap is IJsViewManifestMap;
    protected static IsJsViewManifest(manifest: ViewManifest): manifest is IJsViewManifest;
    protected static IsJsViewMapItem(item: ViewMapItem): item is JsViewMapItem;
    protected static IsMangoDesignDoc(designDoc: any): designDoc is IMangoDesignDocManifest;
    protected static IsMangoDesignDocManifest(designDoc: DesignDocManifest): designDoc is IMangoDesignDocManifest;
    protected static IsMangoViewManifestMap(manifestMap: ViewManifestMap): manifestMap is IMangoViewManifestMap;
    protected static IsMangoViewManifest(manifest: ViewManifest): manifest is IMangoViewManifest;
    protected static IsMangoViewMapItem(item: ViewMapItem): item is IMangoViewMapItem;
}
