export declare enum DesignDocType {
    JAVASCRIPT = "JAVASCRIPT",
    MANGO = "MANGO"
}
export declare enum DesignDocLanguage {
    JAVASCRIPT = "javascript",
    MANGO = "query"
}
export declare type JsViewMapItem = string;
export interface IJsViewManifest {
    version: string;
    map: JsViewMapItem;
    reduce?: string;
}
export interface IJsViewManifestMap {
    [viewName: string]: IJsViewManifest;
}
export interface IJsDesignDocManifest {
    type: DesignDocType.JAVASCRIPT;
    views: IJsViewManifestMap;
}
export interface IMangoViewMapItem {
    fields: {
        [field: string]: string;
    };
}
export interface IMangoViewManifest {
    version: string;
    map: IMangoViewMapItem;
    reduce?: string;
}
export interface IMangoViewManifestMap {
    [viewName: string]: IMangoViewManifest;
}
export interface IMangoDesignDocManifest {
    type: DesignDocType.MANGO;
    views: IMangoViewManifestMap;
}
export declare type ViewMapItem = JsViewMapItem | IMangoViewMapItem;
export declare type ViewManifest = IJsViewManifest | IMangoViewManifest;
export declare type ViewManifestMap = IJsViewManifestMap | IMangoViewManifestMap;
export declare type DesignDocManifest = IJsDesignDocManifest | IMangoDesignDocManifest;
export interface IDesignDocument {
    date_created: string;
    last_updated: string;
    views: ViewManifestMap;
    language: DesignDocLanguage;
}
export interface IDesignDocManifestMap {
    [designDocName: string]: DesignDocManifest;
}
export interface IDesignDocSyncProvider {
    get(id: string): Promise<any>;
    insert(data: any, id?: string): Promise<any>;
    update(data: any, id: string): Promise<any>;
}
export declare class DesignDocSyncException extends Error {
    constructor(message: string);
}
