"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class MockBulkToolProvider {
    constructor(provider) {
        this.provider = provider;
    }
    bulkUpdate(docs) {
        return __awaiter(this, void 0, void 0, function* () {
            const results = [];
            for (const doc of docs) {
                const result = yield this.provider.update(doc, doc._id, doc._rev);
                results.push(result);
            }
            return results;
        });
    }
    bulkDelete(docs) {
        return __awaiter(this, void 0, void 0, function* () {
            const results = [];
            for (const doc of docs) {
                const result = yield this.provider.delete(doc._id, doc._rev);
                results.push(result);
            }
            return results;
        });
    }
    getIdList(selector) {
        const query = {
            selector,
            fields: ['_id'],
        };
        return this.provider.find(query);
    }
    getDocGroup(docs) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = {
                total_rows: docs.length,
                offset: 0,
                rows: [],
            };
            for (const doc of docs) {
                const document = yield this.provider.get(doc._id);
                response.rows.push(document);
            }
            return response;
        });
    }
}
exports.MockBulkToolProvider = MockBulkToolProvider;
