import { IBulkUpdateResponseItem, IBulkToolProvider } from '../BulkTool';
import { IDesignDocManifestMap } from '../Design';
import { ICouchProvider, IDocumentModificationResult, IFindResults, ViewResultResponse, CouchDocument, IDocumentViewParams, ICouchFactory, IMangoQuery, ICouchDocument } from '../Interfaces/CouchTypes';
import { IAggregateView } from '../View/AggregateView';
import { AggregateViewEngine } from '../View/ViewEngine';
export declare function GenerateMockProvider(manifestLocator: (databaseName: string) => IDesignDocManifestMap): ICouchFactory;
export declare class MockProviderManager {
    private static readonly Instances;
    static AddInstance(name: string, instance: ICouchProvider): void;
    static PreloadInstance(name: string, docs: {
        data: any;
        id?: string | undefined;
    }[]): Promise<void>;
}
export declare class MockProvider implements ICouchProvider {
    private readonly designDocs;
    private readonly store;
    private bulkTool;
    constructor(manifest?: IDesignDocManifestMap);
    getBulkTool(): IBulkToolProvider;
    get(id: string): Promise<CouchDocument>;
    insert(data: any, id?: string | undefined): Promise<IDocumentModificationResult>;
    update(data: any, id: string, rev: string): Promise<IDocumentModificationResult>;
    delete(id: string, rev: string): Promise<IDocumentModificationResult>;
    view(designDocument: string, view: string, options?: IDocumentViewParams): Promise<ViewResultResponse>;
    find(query: IMangoQuery): Promise<IFindResults>;
    bulkUpdate(docs: ICouchDocument[]): Promise<IBulkUpdateResponseItem[]>;
    viewEngine(designDocument: string, aggregateViews: IAggregateView[]): AggregateViewEngine;
}
