import { IJsViewManifest } from '../Design/Interfaces';
import { IViewIndexItem, IViewResult, ICouchDocument, IDocumentViewParams, ViewResultResponse } from '../Interfaces/CouchTypes';
export interface IReduceOptions {
    group?: boolean;
    groupLevel?: number;
    rereduce?: boolean;
    sorted?: boolean;
}
export declare class MockView {
    private currentItem;
    private readonly viewIndex;
    private mapFunction;
    private reduceFunction;
    constructor(manifest: IJsViewManifest);
    get(id: string): IViewIndexItem[];
    update(doc: ICouchDocument): void;
    delete(id: string): void;
    map(doc: ICouchDocument): void;
    query(options?: IDocumentViewParams): ViewResultResponse;
    reduce(indexItems: IViewIndexItem[], { group, groupLevel, rereduce, sorted }: IReduceOptions): any;
    collectIndexItems(): IViewResult[];
    private emit;
    private queryWithOptions;
    private filterIndexRowsWithKeyOptions;
}
declare function MapFunctionFromString(parent: any, str: string, emit: (parent: any) => (key: any, value: any) => void): any;
declare function ReduceFunctionFromString(str: string): (keys: any, values: any, rereduce?: boolean) => any;
export declare function getUtilities(): {
    MapFunctionFromString: typeof MapFunctionFromString;
    ReduceFunctionFromString: typeof ReduceFunctionFromString;
};
export {};
