"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CASE_INSENSITIVE_MODE = '(?i)';
const MULTILINE_MODE = '(?m)';
function ConvertInlineModifiers(regexPattern) {
    let result = regexPattern;
    let flags = '';
    let trimIndex = -1;
    const caseInsensitiveIndex = result.indexOf(CASE_INSENSITIVE_MODE);
    if (caseInsensitiveIndex > -1) {
        trimIndex = caseInsensitiveIndex + 4;
        if (caseInsensitiveIndex === 0) {
            result = result.substring(trimIndex);
        }
        else {
            result = result.substring(0, caseInsensitiveIndex) + result.substring(trimIndex);
        }
        flags += 'i';
    }
    const multilineIndex = result.indexOf(MULTILINE_MODE);
    if (multilineIndex > -1) {
        trimIndex = multilineIndex + 4;
        if (multilineIndex === 0) {
            result = result.substring(trimIndex);
        }
        else {
            result = result.substring(0, multilineIndex) + result.substring(trimIndex);
        }
        flags += 'm';
    }
    return { pattern: result.replace(/\(\?[imsx]\)/g, ''), flags };
}
exports.ConvertInlineModifiers = ConvertInlineModifiers;
