export declare const MAJOR = "MAJOR";
export declare const MINOR = "MINOR";
export declare const PATCH = "PATCH";
export declare const enum SemanticVersionSection {
    MAJOR = 0,
    MINOR = 1,
    PATCH = 2
}
export interface IVersionedObject {
    version: string;
}
export declare enum VersionComparisonResult {
    LESS_THAN = 0,
    EQUAL_TO = 1,
    GREATER_THAN = 2
}
export declare type SemanticVersionValueType = string | number;
export declare type SemanticVersionArray = SemanticVersionValueType[];
export declare type SemanticVersion = string | SemanticVersionArray;
export declare function ValidateVersion(version: SemanticVersion): void;
export declare function VersionComparison(left: SemanticVersion, right: SemanticVersion): VersionComparisonResult;
export declare function IncrementMajor(version: SemanticVersion): string;
export declare function IncrementMinor(version: SemanticVersion): string;
export declare function IncrementPatch(version: SemanticVersion): string;
export declare class SemanticVersionException extends Error {
    constructor(message: string);
}
