"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function CanBeAPositiveInteger(value) {
    if (IsNumber(value)) {
        if (value === 0) {
            return !(1 / value === -Infinity);
        }
        else if (value > 0) {
            return Number.isInteger(value);
        }
        else {
            return false;
        }
    }
    else if (IsString(value)) {
        const number = Math.floor(Number(value));
        return String(number) === value && number >= 0 && Number.isInteger(number);
    }
    else {
        return false;
    }
}
exports.CanBeAPositiveInteger = CanBeAPositiveInteger;
function CanBeMinusZero(value) {
    if (IsNumber(value)) {
        return 1 / value === -Infinity;
    }
    else if (IsString(value)) {
        return value === `-0`;
    }
    else {
        return false;
    }
}
exports.CanBeMinusZero = CanBeMinusZero;
function IsArray(value) {
    return Array.isArray(value);
}
exports.IsArray = IsArray;
function IsAnEmptyArray(value) {
    return Array.isArray(value) && value.length === 0;
}
exports.IsAnEmptyArray = IsAnEmptyArray;
function IsBoolean(value) {
    return typeof value === 'boolean';
}
exports.IsBoolean = IsBoolean;
function IsNotAnArray(value) {
    return !IsArray(value);
}
exports.IsNotAnArray = IsNotAnArray;
function IsNull(value) {
    return value === null;
}
exports.IsNull = IsNull;
function IsObject(value) {
    return value && typeof value === 'object' && value.constructor === Object;
}
exports.IsObject = IsObject;
function IsAnEmptyObject(value) {
    return Boolean(value) && value.constructor === Object && Object.keys(value).length === 0;
}
exports.IsAnEmptyObject = IsAnEmptyObject;
function IsTruthy(value) {
    return Boolean(value);
}
exports.IsTruthy = IsTruthy;
function IsFalsy(value) {
    return !IsTruthy(value);
}
exports.IsFalsy = IsFalsy;
function IsUndefined(value) {
    return typeof value === 'undefined';
}
exports.IsUndefined = IsUndefined;
function IsDefined(value) {
    return typeof value !== 'undefined';
}
exports.IsDefined = IsDefined;
function IsNotANumber(value) {
    return !IsNumber(value);
}
exports.IsNotANumber = IsNotANumber;
function IsNumber(value) {
    return typeof value === 'number' && Number.isFinite(value);
}
exports.IsNumber = IsNumber;
function IsNotAPositiveInteger(value) {
    return !IsAPositiveInteger(value);
}
exports.IsNotAPositiveInteger = IsNotAPositiveInteger;
function IsAPositiveInteger(value) {
    if (IsNumber(value)) {
        if (value === 0) {
            return !(1 / value === -Infinity);
        }
        else {
            return value > 0 && Number.isInteger(value);
        }
    }
    return false;
}
exports.IsAPositiveInteger = IsAPositiveInteger;
function IsAnEmptyString(value) {
    return IsString(value) && value.length < 1;
}
exports.IsAnEmptyString = IsAnEmptyString;
function IsNotAString(value) {
    return !IsString(value);
}
exports.IsNotAString = IsNotAString;
function IsString(value) {
    return typeof value === 'string' || value instanceof String;
}
exports.IsString = IsString;
