"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class AggregateView {
    constructor(aggregateView) {
        Object.assign(this, aggregateView);
    }
}
exports.AggregateView = AggregateView;
class AggregateViewFactory extends AggregateView {
    constructor() {
        super();
    }
    static Create(config) {
        if (!this.ConfigIsValid(config)) {
            throw new Error('Invalid AggregateView configuation.');
        }
        return new AggregateView(config);
    }
    static ConfigIsValid(config) {
        const { childMappings, name, rootType } = config;
        if (!name || name === '' || !rootType || rootType === '') {
            return false;
        }
        const childTypes = childMappings.map(child => child.type);
        const uniqueChildTypes = new Set(childMappings);
        if (childTypes.length > uniqueChildTypes.size) {
            return false;
        }
        return true;
    }
}
exports.AggregateViewFactory = AggregateViewFactory;
