import { DocumentViewParams } from 'nano';
import { BulkDeleteList, BulkUpdateResponseList, BulkDeleteResponseList } from './BulkTool/BulkTool';
import { IDesignDocSyncProvider, IDesignDocManifestMap } from './Design/Interfaces';
import { IAggregateView } from './View/AggregateView';
import { AggregateViewEngine } from './View/ViewEngine';
import { ICouchDocument } from './Interfaces';
export declare class Instance {
    private static readonly _instance;
    static readonly Instance: any;
}
export declare class Couch implements IDesignDocSyncProvider {
    private readonly connection;
    db: any;
    private bulkTool;
    private readonly dbName;
    ready: Promise<any>;
    constructor(databaseName: string, connection?: any);
    initErrorCount: number;
    private init;
    find(selector: any): Promise<any>;
    get(id: string): Promise<any>;
    insert(data: any, id?: string): Promise<any>;
    syncDesignDocs(manifest: IDesignDocManifestMap): Promise<void>;
    viewEngine(designDocument: string, aggregateViews: IAggregateView[]): Promise<AggregateViewEngine>;
    view(designDocument: string, view: string, options?: DocumentViewParams): Promise<any>;
    update(data: any, id: any): Promise<{}>;
    patch(data: any, id: any): Promise<{}>;
    bulkDelete(docs: BulkDeleteList): Promise<BulkDeleteResponseList>;
    bulkUpdate(docs: ICouchDocument[]): Promise<BulkUpdateResponseList>;
    delete(id: any): Promise<boolean>;
    readonly instance: any;
}
declare const nanoInstance: any;
export { nanoInstance };
export * from './BulkTool';
export * from './CouchProvider';
export * from './Design';
export * from './Interfaces';
export * from './Mock';
export * from './View';
